//---------------------------------------------------------------------
// sharp Cyberstick driver
//  by Takuya Matsubara / NICO Corp. 2006-2008
// http://www.nicotak.com/usb/

// 얳ۏ؂łB


#include "fx2.h"
#include "fx2regs.h"
#include "cystick.h"

#define CYBER_PORT  IOA	// LEDp|[g
#define CYBER_DDR   OEA	 // LEDp|[g
#define CYBER_PIN   IOA	// LEDp|[g
#define CYBER_DATAMSK  0xf	 // LEDp|[g
#define CYBER_LHBIT    (1<<4)	 // LEDp|[g
#define CYBER_ACKBIT   (1<<5)	 // LEDp|[g
#define CYBER_LH_EQHIGH   (CYBER_PIN&CYBER_LHBIT)
#define CYBER_ACK_EQHIGH  (CYBER_PIN&CYBER_ACKBIT)
#define CYBER_LH_EQLOW    ((CYBER_PIN&CYBER_LHBIT)==0)
#define CYBER_ACK_EQLOW   ((CYBER_PIN&CYBER_ACKBIT)==0)

#define CYBER_REQPORT  IOA	// p|[g
#define CYBER_REQDDR   OEA	 // p|[g
#define CYBER_REQBIT   (1<<6)	// p|[g
#define CYBER_REQOFF   CYBER_REQPORT|=CYBER_REQBIT	// p|[g
#define CYBER_REQON    CYBER_REQPORT&=~CYBER_REQBIT	// p|[g

#define TIMEOUTMAX 30000

char speed=0;	//0-3
//char cycle=0;	//0-5

char temp[12];

char cyber_get(unsigned char *p)
{
int loopcnt;
int timeout;
int tempcnt=0;
char lhlogic=0;

	CYBER_REQDDR |= CYBER_REQBIT;
	CYBER_REQOFF;
	CYBER_REQON;

	for(loopcnt=0; loopcnt<5; loopcnt++){

		if(speed == loopcnt)
			CYBER_REQOFF;

		for(timeout = 0;;timeout++)
		{
			if(CYBER_LH_EQLOW)break;
			if(timeout==TIMEOUTMAX)return(-1);
		}
		for(timeout = 0;;timeout++)
		{
			if(CYBER_ACK_EQLOW)break;
			if(timeout==TIMEOUTMAX)return(-1);
		}
		temp[tempcnt++] = CYBER_PIN & CYBER_DATAMSK;

		for(timeout = 0;;timeout++)
		{
			if(CYBER_LH_EQHIGH)break;
			if(timeout==TIMEOUTMAX)return(-1);
		}
		for(timeout = 0;;timeout++)
		{
			if(CYBER_ACK_EQLOW)break;
			if(timeout==TIMEOUTMAX)return(-1);
		}
		temp[tempcnt++] = CYBER_PIN & CYBER_DATAMSK;
	}
	*p++ = (temp[0] << 4)| temp[1];	// button
	*p++ = (temp[3] << 4)| temp[7];	// x 
	*p++ = (temp[2] << 4)| temp[6];	// y
	*p++ = (temp[4] << 4)| temp[8];	// throttle

//	cycle++;
//	if(cycle >=6)cycle=0;
return(0);
}


