;;cyberstick-USBϊ@ for EZUSB-FX2@by 

;;-----------------------------------------------------------------------------
;;   File:      dscr.a51
;;   Contents:   This file contains descriptor data tables.  
;;
;;   Copyright (c) 1997 AnchorChips, Inc. All rights reserved
;;-----------------------------------------------------------------------------
   
DSCR_DEVICE   equ   1   ;; Descriptor type: Device
DSCR_CONFIG   equ   2   ;; Descriptor type: Configuration
DSCR_STRING   equ   3   ;; Descriptor type: String
DSCR_INTRFC   equ   4   ;; Descriptor type: Interface
DSCR_ENDPNT   equ   5   ;; Descriptor type: Endpoint
DSCR_DEVQUAL  equ   6   ;; Descriptor type: Device Qualifier

DSCR_DEVICE_LEN   equ   18
DSCR_CONFIG_LEN   equ    9
DSCR_INTRFC_LEN   equ    9
DSCR_ENDPNT_LEN   equ    7
DSCR_DEVQUAL_LEN  equ   10

ET_CONTROL   equ   0   ;; Endpoint type: Control
ET_ISO       equ   1   ;; Endpoint type: Isochronous
ET_BULK      equ   2   ;; Endpoint type: Bulk
ET_INT       equ   3   ;; Endpoint type: Interrupt

public      DeviceDscr, DeviceQualDscr, HighSpeedConfigDscr, FullSpeedConfigDscr, StringDscr, UserDscr

public      hidDscr,ReportDscr,ReportDscrEnd


DSCR   SEGMENT   CODE PAGE

;;-----------------------------------------------------------------------------
;; Global Variables
;;-----------------------------------------------------------------------------
      rseg DSCR      ;; locate the descriptor table in on-part memory.

DeviceDscr:   
      db   DSCR_DEVICE_LEN ;; Descriptor length
      db   DSCR_DEVICE     ;; Decriptor type
      dw   0001H           ;; Specification Version (BCD)
      db   00H             ;; Device class
      db   00H             ;; Device sub-class
      db   00H             ;; Device sub-sub-class
      db   64              ;; Maximum packet size
      dw   3412H           ;; Vendor ID  (1234H)*KȂ̂Œ
      dw   0804H           ;; Product ID (0408H )*KȂ̂Œ
      dw   0000H           ;; Product version ID
      db   1               ;; Manufacturer string index
      db   2               ;; Product string index
      db   0               ;; Serial number string index
      db   1               ;; Number of configurations

DeviceQualDscr:
      db   DSCR_DEVQUAL_LEN ;; Descriptor length
      db   DSCR_DEVQUAL     ;; Decriptor type
      dw   0001H            ;; Specification Version (BCD)
      db   00H              ;; Device class
      db   00H              ;; Device sub-class
      db   00H              ;; Device sub-sub-class
      db   64               ;; Maximum packet size
      db   1                ;; Number of configurations
      db   0                ;; Reserved

HighSpeedConfigDscr:   
      db   DSCR_CONFIG_LEN ;; Descriptor length
      db   DSCR_CONFIG     ;; Descriptor type
      db   (HighSpeedConfigDscrEnd-HighSpeedConfigDscr) mod 256 ;; Total Length (LSB)
      db   (HighSpeedConfigDscrEnd-HighSpeedConfigDscr)  /  256 ;; Total Length (MSB)
      db   1               ;; Number of interfaces
      db   1               ;; Configuration number
      db   0               ;; Configuration string
      db   10000000b       ;; Attributes (b7 - buspwr, b6 - selfpwr, b5 - rwu)
      db   50              ;; Power requirement (div 2 ma)

;; Interface Descriptor
      db   DSCR_INTRFC_LEN ;; Descriptor length
      db   DSCR_INTRFC     ;; Descriptor type
      db   0               ;; Zero-based index of this interface
      db   0               ;; Alternate setting
      db   1               ;; Number of end points 
      db   03H             ;; Interface class
      db   00H             ;; Interface sub class
      db   00H             ;; Interface sub sub class
      db   0               ;; Interface descriptor string index

;; HID Descriptor
hidDscr:
      db   9              ;; length of HID desc.
      db   21h            ;; HID descriptor
      db   10h            ;;
      db   01h            ;; version
      db   00h            ;; Country Code (not use)
      db   01h            ;; Num HID descriptor (1)
      db   22h            ;; report descriptor
      db   ReportDscrEnd-ReportDscr
      db   0              ;; HID descriptor size

;; Endpoint Descriptor
      db   DSCR_ENDPNT_LEN ;; Descriptor length
      db   DSCR_ENDPNT     ;; Descriptor type
      db   81H             ;; Endpoint number, and direction
      db   ET_INT          ;; Endpoint type
      db   40H             ;; Maximun packet size (LSB)
      db   00H             ;; Max packect size (MSB)
      db   10H             ;; Polling interval

HighSpeedConfigDscrEnd:

FullSpeedConfigDscr:   
      db   DSCR_CONFIG_LEN ;; Descriptor length
      db   DSCR_CONFIG     ;; Descriptor type
      db   (FullSpeedConfigDscrEnd-FullSpeedConfigDscr) mod 256 ;; Total Length (LSB)
      db   (FullSpeedConfigDscrEnd-FullSpeedConfigDscr)  /  256 ;; Total Length (MSB)
      db   1               ;; Number of interfaces
      db   1               ;; Configuration number
      db   0               ;; Configuration string
      db   10000000b       ;; Attributes (b7 - buspwr, b6 - selfpwr, b5 - rwu)
      db   50              ;; Power requirement (div 2 ma)

;; Interface Descriptor
      db   DSCR_INTRFC_LEN ;; Descriptor length
      db   DSCR_INTRFC     ;; Descriptor type
      db   0               ;; Zero-based index of this interface
      db   0               ;; Alternate setting
      db   1               ;; Number of end points 
      db   03H             ;; Interface class
      db   00H             ;; Interface sub class
      db   00H             ;; Interface sub sub class
      db   0               ;; Interface descriptor string index

;; HID Descriptor
      db   9              ;; length of HID desc.    
      db   21h            ;; HID descriptor
      db   10h            ;;
      db   01h            ;; version
      db   00h            ;; Country Code (not use)
      db   01h            ;; Num HID descriptor (1)
      db   22h            ;; report descriptor
      db   ReportDscrEnd-ReportDscr
      db   0              ;; HID descriptor size

;; Endpoint Descriptor
      db   DSCR_ENDPNT_LEN ;; Descriptor length
      db   DSCR_ENDPNT     ;; Descriptor type
      db   81H             ;; Endpoint number, and direction
      db   ET_INT          ;; Endpoint type
      db   40H             ;; Maximun packet size (LSB)
      db   00H             ;; Max packect size (MSB)
      db   10H             ;; Polling interval

FullSpeedConfigDscrEnd:

ReportDscr:
      db    05h,01h          ;USAGE_PAGE(Generic Desktop)
      db    09h,05h          ;USAGE (game pad)
      db    0a1h,01h         ;COLLECTION (Application)
      db    05h,02h          ;USAGE_PAGE()
      db    0Bh,0BBh,0,2,0   ;USAGE ()
      db    15h,81h          ;LOGICAL_MINIMUM (-127)
      db    25h,7Fh          ;LOGICAL_MAXIMUM (127)
      db    75h,08h          ;REPORT_SIZE (8)
      db    95h,01h          ;REPORT_COUNT (1)
      db    81h,02h          ;INPUT (Data,Var,Abs)
      db    05h,01h          ;USAGE_PAGE(Generic Desktop)
      db    09h,01h          ;USAGE (Pointer)
      db    0a1h,00h         ;COLLECTION (Physical)
      db    09h,30h          ;USAGE (X)
      db    09h,31h          ;USAGE (Y)
      db    15h,0h           ;LOGICAL_MINIMUM (0)
      db    26h,0ffh,00h     ;LOGICAL_MAXIMUM (255)
      db    95h,02h          ;REPORT_COUNT (2)
      db    75h,08h          ;REPORT_SIZE (8)
      db    81h,02h          ;INPUT (Data,Var,Abs)
      db    0c0h             ;END_COLLECTION     
      db    05h,09h          ;USAGE_PAGE (Button)
      db    19h,01h          ;USAGE_MINIMUM (Button 1)
      db    29h,08h          ;USAGE_MAXIMUM (Button 8)
      db    15h,00h          ;LOGICAL_MINIMUM (0)
      db    25h,01h          ;LOGICAL_MAXIMUM (1)
      db    95h,08h          ;REPORT_COUNT (8)
      db    75h,01h          ;REPORT_SIZE (1)
      db    81h,02h          ;INPUT (Data,Var,Abs)
      db    0c0h             ;END_COLLECTION
ReportDscrEnd:

;;      db   00H               ;;WORD ALIGN

StringDscr:

StringDscr0:   
      db   StringDscr0End-StringDscr0      ;; String descriptor length
      db   DSCR_STRING
      db   09H,04H
StringDscr0End:

StringDscr1:   
      db   StringDscr1End-StringDscr1      ;; String descriptor length
      db   DSCR_STRING
      db   'M',00
      db   'y',00
      db   'N',00
      db   'a',00
      db   'm',00
      db   'e',00
StringDscr1End:

StringDscr2:   
      db   StringDscr2End-StringDscr2      ;; Descriptor length
      db   DSCR_STRING
      db   'C',00
      db   'S',00
      db   '-',00
      db   'U',00
      db   'S',00
      db   'B',00
      db   ' ',00
      db   'C',00
      db   'O',00
      db   'N',00
      db   'V',00
      db   '.',00
StringDscr2End:

UserDscr:      
      dw   0000H
      end
      
